<?php 
/*************************************************************************** 
 * 
 *                              newscore.php 
 *                              ------------ 
 *   begin                : Wednesday, Sept 26th, 2007
 *   copyright            : (c)2003-2007 dEfEndEr www.phpbb-arcade.com 
 *   email                : defenders_realm@yahoo.com 
 * 
 *   $Id: newscore.php, v2.2.0 2007/26/09 12:59:59 dEfEndEr Exp $ 
 * 
 *************************************************************************** 
 * 
 *   This program is free software; you can redistribute it and/or modify 
 *   it under the terms of the GNU General Public License as published by 
 *   the Free Software Foundation; either version 2 of the License, or 
 *   (at your option) any later version. 
 * 
 *************************************************************************** 
 * 
 *   This is a MOD for phpbb v2.0.6+. The phpbb group has all rights to the 
 *   phpbb source. They can be contacted at : 
 *    
 *      I-Net : www.phpbb.com 
 *      E-Mail: support@phpbb.com 
 * 
 *   If you have made any changes then please notify me so they can be added 
 *   if they are improvments. You of course will get the credit for helping 
 *   out. If you would like to see other MODs that I have made then check 
 *   out our forum at : www.phpbb-arcade.com 
 * 
 * 	CREDITS: 
 *  Napoleon - Original Activity Mod v2.0.0
 *  Whoo
 *  Painkiller - Add-On & Support
 *  Mark - Add-On & Support
 *  Minesh - Add-On's & Support
 *  ~Maverick~ - Add-On's
 *  Zorial - Add-On's
 *  Madman - Chief Tester :)
 *
 ***************************************************************************
 *
 * Author Notes:
 *
 * v2.0.6 includes 'arcade_hash' data for greater security.
 * v2.0.7 includes favourites code, better error detection and place numbering.
 * v2.0.8 includes support for Invasion Power Arcade (IBProArcade) games
 *			also SMF Games
 * v2.1.1 includes support for pnFlashGames games
 * v2.1.2 Better Session Managment Added 
 * v2.1.3 Auto Prune System Added, moved away from board_config
 * v2.1.4 Tournament feature support and Guest cookie System added 
 *
 ***************************************************************************/

define('IN_PHPBB', true); 

$phpbb_root_path = './'; 
include_once($phpbb_root_path . 'extension.inc'); 
include_once($phpbb_root_path . 'common.'.$phpEx); 
include_once($phpbb_root_path . 'includes/functions_arcade.'.$phpEx);
//
// Start session management 
//
$userdata			= session_pagestart($user_ip, PAGE_ARCADE_SCORE); 
init_userprefs($userdata); 
$version      = $arcade->arcade_config('version');
$session_info = $arcade->get_session();
$mode         = $arcade->pass_var('mode', '');
$arcade->del_session($session_info['arcade_hash']);
$game_name    = $session_info['game_name'];
//
//  Get the Required information for each game type
//
switch($session_info['score_type'])
{
//
//  Old Style Games (only works if cheat mode is off)
//
    case ARCADE_GET:
    	if ($mode && !$arcade->arcade_config['games_cheat_mode'])
    	{
        $arcade->game_name  = $arcade->pass_var('game_name', '');
        $arcade->score      = $arcade->pass_var('score', 0);
    	}
    	else
    	{
     		$arcade->log_game('BAD_GAME', $session_info['game_name'] . '=>' . $arcade->game_name. ' ' . $arcade->score);
    		$arcade->message = $lang['error_game_info_data']; 
      }
      break;
//
//  Whoo's Mode
//      
    case ARCADE_POST:
      $arcade->game_name  = $arcade->pass_var('game_name', '');
      $arcade->score      = $arcade->pass_var('score', 0);
      break;
//
//  dEfEndErs Mode
//      
    case ARCADE_NEW:
      $arcade->game_name  = $session_info['game_name'];
      $arcade->score      = $arcade->pass_var('score', 0);
      break;
//
//  IBProArcade Games
// 
    case ARCADE_IBPRO:
      $arcade->game_name  = $arcade->pass_var('gname', '');
      $arcade->score      = $arcade->pass_var('gscore', 0);
      break;
//
//  IBProArcade v3 Games
//
    case ARCADE_IBPROv3:
      $arcade->score      = $arcade->pass_var('gscore', 0);
      break;
//
//  Mixed Mode (Used when game send differing info back)
//
    case ARCADE_MIXED:
      $arcade->game_name  = $arcade->pass_var('game_name', '');
      $arcade->score      = $arcade->pass_var('score', 0);
      break;
//
//  pnFlashGames Mode, used here for v1 support
//
    case ARCADE_pnFlashGames:
      $arcade->game_name  = $arcade->pass_var('game_name', '');
      $arcade->score      = $arcade->pass_var('score', 0);
      break;
//
//  VBulletin Arcade v3 Games
//
    case ARCADE_vBULLETIN:
      $arcade->game_name  = $arcade->pass_var('gamename', '');
      $arcade->score      = $arcade->pass_var('score', 0);
      break;  
//
//  Default will be Zero or Junk, so we need to see if the user is admin or mod
//
    default:
//
//  Collect as much passed data as we can :)
//
      $gscore           = $arcade->pass_var('gscore', 0);
      $gname            = $arcade->pass_var('gname', '');
      $score            = $arcade->pass_var('score', 0);
      $gamename         = $arcade->pass_var('game_name', '');

      if($userdata['user_level'] == ADMIN || $userdata['user_level'] == MOD)
      {
//
//  Here we have to work out what score saving method we are going
//  to save back to the game..!
//
        $arcade->game_name = $arcade->arcade_session['game_name'];
        $arcade->score = $score;

        if(!empty($gscore) && empty($gname))
        {
          $arcade->score_type = ARCADE_IBPROv3;
          $arcade->score = $gscore;
        }
        else if(!empty($gscore) && !empty($gname))
        {
          $arcade->score_type = ARCADE_IBPRO;
          $arcade->score = $gscore;
        }
        else if((!empty($arcade->arcade_hash)) && strlen($arcade->arcade_hash == 32))
        {
          $arcade->score_type = ARCADE_NEW;
        }
        else if(!empty($HTTP_POST_VARS['gamename']))
        {
          $arcade->score_type = ARCADE_vBULLETIN;
        }
        else if(!empty($HTTP_POST_VARS['score']))
        {
          $arcade->score_type = ARCADE_POST;
        }
        else if(!empty($HTTP_GET_VARS['score']) && !empty($mode))
        {
          $arcade->score_type = ARCADE_GET;
        }
        else
        {
        	$arcade->score_type = ARCADE_MIXED;
        }
      }
      else
      {
        $arcade->log_game('GAME', $lang['arcade_admin_must_play'] . ' game_name=>' . $arcade->game_name . ' score=>' . $arcade->score);
      }
      break;
}
//
//  Final Check to see if we are getting the correct info back
//
if(($arcade->game_name != $game_name) && ($arcade->arcade_config['games_cheat_mode']))
{
//
//  OK, Huston we have a problem
//  Some games have incorrectly been set-up as WHOO or NEW method.
//  Lets Just check and see!!!
//
  if(empty($arcade->game_name) && !empty($gname))
  {
//
//  Looks like it...!
//    
    if($userdata['user_level'] == ADMIN || $userdata['user_level'] == MOD)
    {
      $score_type = ARCADE_IBPRO;
   		$sql = "UPDATE " . iNA_GAMES . " 
   			SET score_type = '" . $score_type . "'
   				WHERE game_name = '" . $gname . "' LIMIT 1"; 
   		if(!$result = $db->sql_query($sql))
   		{ 
   			$arcade->message_die(GENERAL_ERROR, $lang['no_game_update'] . ' ' .$sql . '<br><br>'.$lang['newscore_close'], "", __LINE__, __FILE__, $sql); 
   		}
    }
    else
    {
      $arcade->message_die(GENERAL_MESSAGE, $lang['arcade_admin_must_play']. $lang['newscore_close']);
    }
  }
}
else if ($arcade->game_name != $game_name)
{
  $arcade->log_game('BAD_GAME', $arcade->game_name. '=>' . $arcade->score . ' SESSION=>' . $game_name);
  $arcade->game_name = $game_name;
  if($arcade->score == 0)
  {
    $arcade->score = $gscore;
  }
}
//
// This will stop ***_ALL_*** template errors :)
//
$template->set_filenames(array('body' => 'arcade_saved_body.tpl')); 
//
//	Make sure that we have been given a Game Name to play with.
//
$arcade->newscore();
//
//	Send to the Template the Required Fields.
//
$template->assign_vars(array(
	'SAVED'		=> $arcade->message, 
	'GAME_NAME' => $session_info['game_desc']
	)); 
//
//	Remove Yesterdays Session Info from Arcade Sessions Table.
//
$sql = "DELETE FROM " . iNA_SESSIONS . "
	WHERE start_time < '" . (time() - 86400) . "'";
$db->sql_query($sql);
//
//  Log Game results..
//
$log = '';
foreach($HTTP_POST_VARS as $key => $value)
{
  $log .= addslashes($key) . '=>' . addslashes(htmlspecialchars($value)) . ' ';
}
$arcade->log_game('GAME', $log);
//
// Generate the page 
//
include($phpbb_root_path . 'includes/page_header.'.$phpEx); 
$template->pparse('body'); 
include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 

?>
